def RK4step(f_rhs,x_n,p,h):
    f_rhs.init()
    #x_dot = f_rhs(x,p)
    x = x_n
    a21 = 0.5
    a32 = 0.5
    a43 = 1
    
    b1 = 1.0/6.0
    b2 = 2.0/6.0
    b3 = 2.0/6.0
    b4 = 1.0/6.0
    
#    K1 = f_rhs(x,p)
    f_rhs.setInput(x,0)
    f_rhs.setInput(p,1)
    f_rhs.evaluate()
    K1 = f_rhs.output()
    
#    K2 = f_rhs(x+h*a21*K1,p)
    f_rhs.setInput(x+h*a21*K1,0)
    f_rhs.setInput(p,1)
    f_rhs.evaluate()
    K2 = f_rhs.output()
        
#    K3 = f_rhs(x+h*(a32*K2),p)
    f_rhs.setInput(x+h*a32*K2,0)
    f_rhs.setInput(p,1)
    f_rhs.evaluate()
    K3 = f_rhs.output()

#    K4 = f_rhs(x+h*(a43*K3),p)
    f_rhs.setInput(x+h*a43*K3,0)
    f_rhs.setInput(p,1)
    f_rhs.evaluate()
    K4 = f_rhs.output()
    
    x_next = x + h*(b1*K1+b2*K2+b3*K3+b4*K4)
    
    return x_next

def RK4step_sym(f_rhs,x_n,p,h):
    f_rhs.init()
    #x_dot = f_rhs(x,p)
    x = x_n
    a21 = 0.5
    a32 = 0.5
    a43 = 1
    
    b1 = 1.0/6.0
    b2 = 2.0/6.0
    b3 = 2.0/6.0
    b4 = 1.0/6.0
    
#    K1 = f_rhs(x,p)
    K1 = f_rhs.call([x,p])[0]
#    K2 = f_rhs(x+h*a21*K1,p)
    K2 = f_rhs.call([x+h*a21*K1,p])[0]
        
#    K3 = f_rhs(x+h*(a32*K2),p)
    K3 = f_rhs.call([(x+h*a32*K2),p])[0]

#    K4 = f_rhs(x+h*(a43*K3),p)
    K4 = f_rhs.call([(x+h*a43*K3),p])[0]
    
    x_next = x + h*(b1*K1+b2*K2+b3*K3+b4*K4)
    
    return x_next


def RK4integrator(f_rhs,x_0,p,h,tf,t0):
    x_n = x_0
    for i in range(int(round((tf-t0)/h))):
        x_n = RK4step(f_rhs,x_n,p,h)
    return x_n

def RK4integratorSX(f_rhs,x_0,p,h,tf,t0):
    x_n = x_0
    for i in range(int(round((tf-t0)/h))):
        x_n = RK4step_sym(f_rhs,x_n,p,h)
    return x_n