import numpy as NP
import pylab
import matplotlib.pyplot as plt


def iceConcentrationParameterPlotting(t0,tf,tn,np,estParam1,estParam2,realParam,name,legend,y_label):
    tn = NP.max([estParam1.shape[0],estParam2.shape[0],realParam.shape[0]])
    tn_diff1 = tn - estParam1.shape[0]
    tn_diff2 = tn - estParam2.shape[0]
    tn_diff3 = tn - realParam.shape[0]
    
    realParam = realParam[:,:np]
    N = realParam.shape[0]
    
    td = (tf-t0)/(tn-1)
       
    tgrid1 = NP.linspace(tn_diff1*td,(N-1)*td,estParam1.shape[0])
    tgrid2 = NP.linspace(tn_diff2*td,(N-1)*td,estParam2.shape[0])
    tgrid3 = NP.linspace(tn_diff3*td,(N-1)*td,realParam.shape[0])
    

    for i in range(np):
        plt.figure(i+1)
        plt.clf()
        plt.subplot(1,1,1)
        plt.title(name[i])
        plt.plot(tgrid3,realParam[:,i])
        plt.plot(tgrid2,estParam2[:,i],'o')
        plt.plot(tgrid1,estParam1[:,i],'^')
        plt.ylim(NP.min([0,1.1*NP.min(NP.hstack([realParam[:,i],estParam1[:,i],estParam2[:,i]]))]), NP.max([1,1.1*NP.max(NP.hstack([realParam[:,i],estParam1[:,i],estParam2[:,i]]))]))
        plt.legend(legend, loc='best')
        plt.grid()
        plt.xlabel(r'$t$ [s]')
        plt.ylabel(y_label[i])#r'$u$ [m/s]'
        pylab.savefig('plots/'+name[i]+'.pdf', bbox_inches=0)
    
    plt.show()

def iceConcentration4ParameterPlotting(t0,tf,tn,np,realParam,estParam1,estParam2,estParam3,name,legend,y_lable):
    tn = NP.max([estParam1.shape[0],estParam2.shape[0],estParam3.shape[0],realParam.shape[0]])
    tn_diff = tn - realParam.shape[0]
    tn_diff1 = tn - estParam1.shape[0]
    tn_diff2 = tn - estParam2.shape[0]
    tn_diff3 = tn - estParam3.shape[0]
    
    realParam = realParam[:,:np]
    N = realParam.shape[0]
    
    td = (tf-t0)/(tn-1)
    
    tgrid = NP.linspace(tn_diff*td,(N-1)*td,realParam.shape[0])   
    tgrid1 = NP.linspace(tn_diff1*td,(N-1)*td,estParam1.shape[0])
    tgrid2 = NP.linspace(tn_diff2*td,(N-1)*td,estParam2.shape[0])
    tgrid3 = NP.linspace(tn_diff3*td,(N-1)*td,estParam3.shape[0])

    for i in range(np):
        plt.figure(i+1)
        plt.clf()
        plt.subplot(1,1,1)
        plt.title(name[i])
        plt.plot(tgrid,realParam[:,i])
        plt.plot(tgrid1,estParam1[:,i],'cs')
        plt.plot(tgrid2,estParam2[:,i],'yo')
        plt.plot(tgrid3,estParam3[:,i],'r^')
        plt.ylim(NP.min([0,1.1*NP.min(NP.hstack([realParam[:,i],estParam1[:,i],estParam2[:,i],estParam3[:,i]]))]), NP.max([1,1.1*NP.max(NP.hstack([realParam[:,i],estParam1[:,i],estParam2[:,i],estParam3[:,i]]))]))
        plt.legend(legend, loc='best')
        plt.grid()
        plt.xlabel(r'$t$ [s]')
        plt.ylabel(y_lable[i])
        pylab.savefig('plots/'+name[i]+'.pdf', bbox_inches=0)
    
    plt.show()
    
    
    
def iceConcentration2ParameterPlotting(t0,tf,tn,np,realParam,estParam1,name,legend,y_lable):
    np = NP.min([estParam1.shape[1],realParam.shape[1]])
    tn = NP.max([estParam1.shape[0],realParam.shape[0]])
    tn_diff = tn - realParam.shape[0]
    tn_diff1 = tn - estParam1.shape[0]
    
    estParam1 = estParam1[:,:np]
    realParam = realParam[:,:np]
    N = realParam.shape[0]
    
    td = (tf-t0)/(tn-1)
    
    tgrid = NP.linspace(tn_diff*td,(N-1)*td,realParam.shape[0])   
    tgrid1 = NP.linspace(tn_diff1*td,(N-1)*td,estParam1.shape[0])

    for i in range(np):
        plt.figure(i+1)
        plt.clf()
        plt.subplot(1,1,1)
        plt.title(name[i])
        plt.plot(tgrid,realParam[:,i])
        plt.plot(tgrid1,estParam1[:,i],'ro')
        plt.ylim(NP.min([0,1.1*NP.min(NP.hstack([realParam[:,i],estParam1[:,i]]))]), NP.max([1,1.1*NP.max(NP.hstack([realParam[:,i],estParam1[:,i]]))]))
        plt.legend(legend, loc='best')
        plt.grid()
        plt.xlabel(r'$t$ [s]')
        plt.ylabel(y_lable[i])
        pylab.savefig('plots/'+name[i]+'.pdf', bbox_inches=0)
    
    plt.show()